#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>

#include <iostream>
#include <string>

using namespace cv;

int main()
{
	std::cout << "Image Splitter"<<std::endl;

	//Set parameters
	int im_file_count = 12;
	int edge_size = 100;

	int count = 0;

	cv::Mat input_image;

	for (int i=0; i<im_file_count; i++) {
		input_image = cv::imread("pictures/"+std::to_string(i)+".jpg", CV_LOAD_IMAGE_COLOR);
		
		int im_w = input_image.cols / edge_size;
		int im_h = input_image.rows / edge_size;

		std::cout << "Image: " << i << ".jpg "<<im_w << " x "<< im_h <<std::endl;

		cv::Mat crop;

		for (int w=0; w<im_w;w++){
		for (int h=0; h<im_h;h++){
			
		cv::Mat roi(input_image(cv::Rect(w*edge_size,h*edge_size,edge_size,edge_size)));		

		std::string path = "out/" + std::to_string(count) +".jpg";
		count++;
 		cv::imwrite(path, roi);

		}}
	}
	
	std::cout << "Done "<< count <<" images..." <<std::endl;

	return 0;
}

